package techreborn.client.gui.autocrafting;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButtonImage;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.item.crafting.ShapedRecipes;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.oredict.ShapedOreRecipe;
import org.lwjgl.opengl.GL11;
import reborncore.common.network.NetworkManager;
import techreborn.client.gui.GuiBase;
import techreborn.client.gui.TRBuilder;
import techreborn.packets.PacketSetRecipe;
import techreborn.tiles.TileAutoCraftingTable;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import static net.minecraft.item.ItemStack.EMPTY;

import techreborn.client.gui.GuiBase.Layer;

/**
 * Created by modmuss50 on 20/06/2017.
 */
public class GuiAutoCrafting extends GuiBase {

	static final ResourceLocation RECIPE_BOOK_TEXTURE = new ResourceLocation("textures/gui/recipe_book.png");
	GuiAutoCraftingRecipeSlector recipeSlector = new GuiAutoCraftingRecipeSlector();
	private GuiButtonImage recipeButton;
	boolean showGui = true;
	InventoryCrafting dummyInv;
	TileAutoCraftingTable tileAutoCraftingTable;

	public GuiAutoCrafting(EntityPlayer player, TileAutoCraftingTable tile) {
		super(player, tile, tile.createContainer(player));
		this.tileAutoCraftingTable = tile;
	}

	@Override
	public void func_73876_c() {
		super.func_73876_c();
		recipeSlector.func_193957_d();
	}

	public void renderItemStack(ItemStack stack, int x, int y) {
		if (stack != field_190927_a) {
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			RenderHelper.func_74520_c();

			RenderItem itemRenderer = Minecraft.func_71410_x().func_175599_af();
			itemRenderer.func_180450_b(stack, x, y);

			GL11.glDisable(GL11.GL_LIGHTING);
		}
	}

	@Override
	protected void func_146979_b(int mouseX, int mouseY) {
		super.func_146979_b(mouseX, mouseY);
		IRecipe recipe = tileAutoCraftingTable.getIRecipe();
		if (recipe != null) {
			renderItemStack(recipe.func_77571_b(), 95, 42);
		}
		final Layer layer = Layer.FOREGROUND;
		this.builder.drawMultiEnergyBar(this, 9, 26, (int) this.tileAutoCraftingTable.getEnergy(), (int) this.tileAutoCraftingTable.getMaxPower(), mouseX, mouseY, 0, layer);
		this.builder.drawProgressBar(this, tileAutoCraftingTable.getProgress(), tileAutoCraftingTable.getMaxProgress(), 120, 44, mouseX, mouseY, TRBuilder.ProgressDirection.RIGHT, layer);

		int mX = mouseX - getGuiLeft();
		int mY = mouseY - getGuiTop();

		if(recipe != null && !tileAutoCraftingTable.customRecipe){
			if (builder.isInRect(91, 66, 23, 23, mX, mY)) {
				List<String> list = new ArrayList<>();
				list.add("Click to clear");
				net.minecraftforge.fml.client.config.GuiUtils.drawHoveringText(list, mX, mY, field_146294_l, field_146295_m, -1, field_146297_k.field_71466_p);
				GlStateManager.func_179140_f();
				GlStateManager.func_179131_c(1, 1, 1, 1);
			}
		}
	}

	//Based of vanilla code
	public void renderRecipe(IRecipe recipe, int x, int y) {
		RenderHelper.func_74520_c();
		GlStateManager.func_179141_d();
		field_146297_k.func_110434_K().func_110577_a(RECIPE_BOOK_TEXTURE);

		this.func_73729_b(x, y, 152, 78, 24, 24);

		int recipeWidth = 3;
		int recipeHeight = 3;
		if (recipe instanceof ShapedRecipes) {
			ShapedRecipes shapedrecipes = (ShapedRecipes) recipe;
			recipeWidth = shapedrecipes.func_192403_f();
			recipeHeight = shapedrecipes.func_192404_g();
		}
		if (recipe instanceof ShapedOreRecipe) {
			ShapedOreRecipe shapedrecipes = (ShapedOreRecipe) recipe;
			recipeWidth = shapedrecipes.getWidth();
			recipeHeight = shapedrecipes.getHeight();
		}
		Iterator<Ingredient> ingredients = recipe.func_192400_c().iterator();
		for (int rHeight = 0; rHeight < recipeHeight; ++rHeight) {
			int j1 = 3 + rHeight * 7;
			for (int rWidth = 0; rWidth < recipeWidth; ++rWidth) {
				if (ingredients.hasNext()) {
					ItemStack[] aitemstack = ingredients.next().func_193365_a();
					if (aitemstack.length != 0) {
						int l1 = 3 + rWidth * 7;
						GlStateManager.func_179094_E();
						int i2 = (int) ((float) (x + l1) / 0.42F - 3.0F);
						int j2 = (int) ((float) (y + j1) / 0.42F - 3.0F);
						GlStateManager.func_179152_a(0.42F, 0.42F, 1.0F);
						GlStateManager.func_179145_e();
						field_146297_k.func_175599_af().func_180450_b(aitemstack[0], i2, j2);
						GlStateManager.func_179140_f();
						GlStateManager.func_179121_F();
					}
				}
			}
		}
		GlStateManager.func_179118_c();
		RenderHelper.func_74518_a();
	}

	@Override
	protected void func_146976_a(final float f, int mouseX, int mouseY) {
		super.func_146976_a(f, mouseX, mouseY);
		final Layer layer = Layer.BACKGROUND;
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				drawSlot(28 + (i * 18), 25 + (j * 18), layer);
			}
		}
		drawOutputSlot(145, 42, layer);
		drawOutputSlot(95, 42, layer);
		drawString("Inventory", 8, 82, 4210752, layer);

		IRecipe recipe = tileAutoCraftingTable.getIRecipe();
		if (recipe != null && ! tileAutoCraftingTable.customRecipe) {
			renderRecipe(recipe, field_147003_i + 91, 66 + field_147009_r);
		}
	}

	@Override
	public void func_73866_w_() {
		super.func_73866_w_();
		recipeSlector.setGuiAutoCrafting(this);
		dummyInv = new InventoryCrafting(new Container() {
			@Override
			public boolean func_75145_c(EntityPlayer playerIn) {
				return false;
			}
		}, 3, 3);
		for (int i = 0; i < 9; i++) {
			dummyInv.func_70299_a(i, ItemStack.field_190927_a);
		}
		this.recipeSlector.func_191856_a(this.field_146294_l, this.field_146295_m, this.field_146297_k, false, this.field_147002_h, dummyInv);
		this.field_147003_i = this.recipeSlector.func_193011_a(false, this.field_146294_l, this.xSize);
	}

	@Override
	public void func_73863_a(int mouseX, int mouseY, float partialTicks) {
		if (showGui) {
			this.recipeSlector.func_191861_a(mouseX, mouseY, 0.1F);
			super.func_73863_a(mouseX, mouseY, partialTicks);
			this.recipeSlector.func_191864_a(this.field_147003_i, this.field_147009_r, false, partialTicks);
		} else {
			super.func_73863_a(mouseX, mouseY, partialTicks);
		}
		this.recipeSlector.func_191876_c(this.field_147003_i, this.field_147009_r, mouseX, mouseY);
	}

	@Override
	protected void func_73864_a(int mouseX, int mouseY, int mouseButton) throws IOException {
		if (!this.recipeSlector.func_191862_a(mouseX, mouseY, mouseButton)) {
			super.func_73864_a(mouseX, mouseY, mouseButton);
		}
		int mX = mouseX - getGuiLeft();
		int mY = mouseY - getGuiTop();

		field_146297_k.func_110434_K().func_110577_a(TRBuilder.GUI_SHEET);
		if (builder.isInRect(91, 66, 23, 23, mX, mY)) {
			setRecipe(null, true);
		}
	}

	@Override
	protected void func_73869_a(char typedChar, int keyCode) throws IOException {
		if (!this.recipeSlector.func_191859_a(typedChar, keyCode)) {
			super.func_73869_a(typedChar, keyCode);
		}
	}

	@Override
	protected void func_184098_a(Slot slotIn, int slotId, int mouseButton, ClickType type) {
		super.func_184098_a(slotIn, slotId, mouseButton, type);
		this.recipeSlector.func_191874_a(slotIn);
	}

	public void func_146281_b() {
		this.recipeSlector.func_191871_c();
		super.func_146281_b();
	}

	public void setRecipe(IRecipe recipe, boolean custom) {
		tileAutoCraftingTable.setCurrentRecipe(recipe, custom);
		NetworkManager.sendToServer(new PacketSetRecipe(tileAutoCraftingTable, recipe, custom));
	}

}
